/*
 *            Gax - Galaxy, Amateur Astronomical Database
 *       Copyright (C) 1998 - manders1@csc.com (Mark Anderson)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details in file GNU-GPL.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gax_cat.h>

extern UB *blk (int n);
extern UB *dsh (int n);
extern UB *hdr (char *s, int n);

ubyte_t	 a [16];

#define	BCD(B,N)	((B >> ((N-1)*4)) & 0xF)

UB *b2a_nnn (UL b)
{
	UB *p = a, f = 0, c;

	if ((c = BCD(b,3)))      { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,2)) || f) { *p++ = c+'0';      } else *p++ = ' ';
	     c = BCD(b,1);         *p++ = c+'0';
							   *p++ = 0;
	return (a);
}

UB *b2a_nn_n (UL b)
{
	UB *p = a, f = 0, c;

	if ((c = BCD(b,3))     ) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,2)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,1)) || f) {
		*p++ = '.';
		*p++ = c+'0';
	} else {
		*p++ = ' ';
		*p++ = ' ';
	}
	*p++ = 0;
	return (a);
}

UB *b2a_nnn_n (UL b)
{
	UB *p = a, f = 0, c;

	if ((c = BCD(b,4))     ) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,3)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,2)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,1)) || f) {
		*p++ = '.';
		*p++ = c+'0';
	} else {
		*p++ = ' ';
		*p++ = ' ';
	}
	*p++ = 0;
	return (a);
}

UB *b2a_nnna (UL b, UB o, UL x)
{
	UB *p = a, f = 0, c;

	if (o) { *p++ = x; *p++ = ' '; }

	if ((c = BCD(b,3))     ) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,2)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,1)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
							   *p++ = 0;
  	if (!f)
  		if (o) strcpy (a, "     ");
  		else   strcpy (a, "   ");

	return (a);
}

UB *b2a_nnnnn (UL b, UB o, UL x)
{
	UB *p = a, f = 0, c;

	if (o) { *p++ = x; *p++ = ' '; }

	if ((c = BCD(b,5))     ) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,4)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,3)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,2)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,1)) || f) { *p++ = c+'0';      } else *p++ = ' ';
							   *p++ = 0;
	return (a);
}

UB *b2a_nnnnna (UL b, UB o, UL x)
{
	UB *p = a, f = 0, c;

	if (o) { *p++ = x; *p++ = ' '; }

	if ((c = BCD(b,6))     ) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,5)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,4)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,3)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,2)) || f) { *p++ = c+'0';      } else *p++ = ' ';
	if ((c = BCD(b,1))     ) {
		if (c == 6) {			/* A=1, B=2, C=3, D=4, E=5, F=6 */
			*p++  = ' ';
			*(a+1)= 'A';
		} else
			*p = c+'A'-1;
	} else
		*p++ = ' ';

	*p++ = 0;
	return (a);
}

UB *b2a_nnnna (UL b, UB o, UL x)
{
	UB *p = a, f = 0, c;

	if (o) { *p++ = x; *p++ = ' '; }

	if ((c = BCD(b,5))     ) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,4)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,3)) || f) { *p++ = c+'0'; f=1; } else *p++ = ' ';
	if ((c = BCD(b,2)) || f) { *p++ = c+'0';      } else *p++ = ' ';
	if ((c = BCD(b,1))     ) { *p++ = c+'A'-1;    } else *p++ = ' ';
							   *p++ = 0;
	return (a);
}

UB *b2a_nnn_nnna (UL b, UB o, UL x)
{
	UB *p = a, f = 0, c;

	if (o) { *p++ = x; *p++ = ' '; }

	if (c = BCD(b,7))   f=1; *p++ = c+'0';
	if (c = BCD(b,6))   f=1; *p++ = c+'0';
	if (c = BCD(b,5))   f=1; *p++ = c+'0';
	                         *p++ = '-';
	if (c = BCD(b,4))   f=1; *p++ = c+'0';
	if (c = BCD(b,3))   f=1; *p++ = c+'0';
	if (c = BCD(b,2))   f=1; *p++ = c+'0';
	if (c = BCD(b,1)) { f=1; *p++ = c+'A'-1; } else *p++ = ' ';
							 *p++ = 0;

 	if (!f)
 		if (o) strcpy (a, "          ");
 		else   strcpy (a, "        ");

	return (a);
}

UB *b2a_nn_nn_nnna (UL b, UB o, UL x)
{
	UB *p = a, f = 0, c;

	if (o) { *p++ = x; }

	*p++ = (b & 0x80000000) ? '-' : '+';
	b &= 0x7FFFFFFF;

	if (c = BCD(b,8))   f=1; *p++ = c+'0';
	if (c = BCD(b,7))   f=1; *p++ = c+'0';
	                         *p++ = '-';
	if (c = BCD(b,6))   f=1; *p++ = c+'0';
	if (c = BCD(b,5))   f=1; *p++ = c+'0';
	                         *p++ = '-';
	if (c = BCD(b,4))   f=1; *p++ = c+'0';
	if (c = BCD(b,3))   f=1; *p++ = c+'0';
	if (c = BCD(b,2))   f=1; *p++ = c+'0';
	if (c = BCD(b,1)) { f=1; *p++ = c+'A'-1; } else *p++ = ' ';
							 *p++ = 0;

 	if (!f)
 		if (o) strcpy (a, "             ");
 		else   strcpy (a, "           ");

	return (a);
}

UB *dsh_pgc (UB o) { return (dsh ((o) ?  7: 5)); }
UB *dsh_ngc (UB o) { return (dsh ((o) ?  7: 5)); }
UB *dsh_ic  (UB o) { return (dsh ((o) ?  7: 5)); }
UB *dsh_ugc (UB o) { return (dsh ((o) ?  8: 6)); }
UB *dsh_mcg (UB o) { return (dsh ((o) ? 12:11)); }
UB *dsh_eso (UB o) { return (dsh ((o) ? 10: 8)); }
UB *dsh_cgc (UB o) { return (dsh ((o) ? 10: 8)); }
UB *dsh_arp (UB o) { return (dsh ((o) ?  7: 5)); }
UB *dsh_mk  (UB o) { return (dsh ((o) ?  7: 5)); }
UB *dsh_vv  (UB o) { return (dsh ((o) ?  7: 5)); }
UB *dsh_m   (UB o) { return (dsh ((o) ?  5: 3)); }
UB *dsh_nam (UB o) { return (dsh (      12   )); }

UB *hdr_pgc (UB o) { return (hdr ("PGC",(o) ?  7: 5)); }
UB *hdr_ngc (UB o) { return (hdr ("NGC",(o) ?  7: 5)); }
UB *hdr_ic  (UB o) { return (hdr ("IC" ,(o) ?  7: 5)); }
UB *hdr_ugc (UB o) { return (hdr ("UGC",(o) ?  8: 6)); }
UB *hdr_mcg (UB o) { return (hdr ("MCG",(o) ? 12:11)); }
UB *hdr_eso (UB o) { return (hdr ("ESO",(o) ? 10: 8)); }
UB *hdr_cgc (UB o) { return (hdr ("CGC",(o) ? 10: 8)); }
UB *hdr_arp (UB o) { return (hdr ("ARP",(o) ?  7: 5)); }
UB *hdr_mk  (UB o) { return (hdr ("MK" ,(o) ?  7: 5)); }
UB *hdr_vv  (UB o) { return (hdr ("VV" ,(o) ?  7: 5)); }
UB *hdr_m   (UB o) { return (hdr ("M"  ,(o) ?  5: 3)); }

UB *hdr_nam (UB n)
{
	static UB name_a [] = "NAME  ";

	name_a [5] = n;

	return (hdr (name_a, 12));
}

UB *b2a_pgc (UL b, UB o) { return (b2a_nnnnn      (b, o, 'P')); }
UB *b2a_ngc (UL b, UB o) { return (b2a_nnnna      (b, o, 'N')); }
UB *b2a_ic  (UL b, UB o) { return (b2a_nnnna      (b, o, 'I')); }
UB *b2a_ugc (UL b, UB o) { return (b2a_nnnnna     (b, o, 'U')); }
UB *b2a_arp (UL b, UB o) { return (b2a_nnnna      (b, o, 'A')); }
UB *b2a_mk  (UL b, UB o) { return (b2a_nnnna      (b, o, 'K')); }
UB *b2a_vv  (UL b, UB o) { return (b2a_nnnna      (b, o, 'V')); }
UB *b2a_m   (UL b, UB o) { return (b2a_nnna       (b, o, 'M')); }
UB *b2a_mcg (UL b, UB o) { return (b2a_nn_nn_nnna (b, o, 'G')); }
UB *b2a_cgc (UL b, UB o) { return (b2a_nnn_nnna   (b, o, 'C')); }
UB *b2a_eso (UL b, UB o) { return (b2a_nnn_nnna   (b, o, 'E')); }

UB *b2a_nam (UB *b)
{
	UB	 n;

	strcpy (a, b);
	n = strlen (b);
	b = a + n;
	n = 12 - n;
	while (n--) *b++ = ' ';
	*b = 0;

	return (a);
}
