/*
 *            Gax - Galaxy, Amateur Astronomical Database
 *       Copyright (C) 1998 - manders1@csc.com (Mark Anderson)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details in file GNU-GPL.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <sys/stat.h>
#include <unistd.h>
#include <gax.h>

gxd_open (filename_p, options_x, permissions_x)
ubyte_t	*filename_p;
ulong_t	 options_x;
ulong_t	 permissions_x;
{
	long_t	fd;

	if ((fd = open (filename_p, options_x, permissions_x)) == -1) {
		gxd_serror ("gxd_open", "open", filename_p);
		return (0);
	}
	return (fd);
}

gxd_close (fd)
long_t	 fd;
{
	close (fd);
}

gxd_read (fd, gxd_p, gxd_n)
long_t	 fd;
 gxd_t	*gxd_p;
long_t	 gxd_n;
{
	long_t	n;
	
	n = read (fd, gxd_p, gxd_n * sizeof (gxd_t));
	if (n != gxd_n * sizeof (gxd_t)) {
		if (n != 0) gxd_nerror ("gxd_read", "read", n);
		return (0);
	}
	return (gxd_n);
}

gxd_write (fd, gxd_p, gxd_n)
long_t	 fd;
 gxd_t	*gxd_p;
long_t	 gxd_n;
{
	if (write (fd, gxd_p, gxd_n * sizeof (gxd_t)) != gxd_n * sizeof (gxd_t)) {
		gxd_nerror ("gxd_write", "write", fd);
		return (0);
	}
	return (gxd_n);
}

gxd_size (filename_p)
ubyte_t	*filename_p;
{
	struct stat status;

	if (stat (filename_p, &status) == -1) {
		gxd_serror ("gxd_size", "stat", filename_p);
		return (0);
	}

	return (status.st_size / sizeof (gxd_t));
}

gxd_nerror (function_p, error_p, number_n)
ubyte_t	*function_p;
ubyte_t	*error_p;
long_t	 number_n;
{
	printf ("%s: %s (%d)\n", function_p, error_p, number_n);
}

gxd_serror (function_p, error_p, string_p)
ubyte_t	*function_p;
ubyte_t	*error_p;
ubyte_t	*string_p;
{
	printf ("%s: %s (%s)\n", function_p, error_p, string_p);
}

