/*
 *            Gax - Galaxy, Amateur Astronomical Database
 *       Copyright (C) 1998 - manders1@csc.com (Mark Anderson)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details in file GNU-GPL.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <time.h>
#include <gax.h>
#include <gax_con.h>

#define Pr printf

help (UB *p)
{
	long_t	 i, j;

if (!p) {
Pr("\n");
Pr(" gax -rMin,Max -dMin,Max -ennnn.n -unnn -c!Con -tx -h* -R|T|SMin,Max\n");
#ifdef GX_Vel
Pr("     -v|p|a|sMin,Max -x|yMin,Max -OCxxx -fx.. -Cx.. -1x.. -mnn -zMin,Max\n");
#else
Pr("     -v|p|a|sMin,Max -x|yMin,Max -OCxxx -fx.. -Cx.. -1x.. -mnn\n");
#endif
Pr("     -L+ddmmss -N+dddmmss -E+nn -H+nn -Dmmdd -Yyyyy @cmd -oout inp\n");
Pr("\n");
Pr(" -c!= Constellation          -N - No Headers           -D - Date\n");
Pr(" -r - RA           [hhmmss]  -v - Visual   Mag [nn.n]  -Y - Year\n");
Pr(" -d - Declination [+ddmmss]  -p - Photo    Magnitude   -L - Latitude\n");
Pr(" -x - Major Dia (') [nnn.n]  -a - Absolute Magnitude   -G - Longitude\n");
Pr(" -y - Minor Dia (')          -s - Surface Brightness   -E - Elevation (ft)\n");
Pr(" -C!= Catalog Name           -h - Help  (*=option)     -H - Horizon  (deg)\n");
Pr(" -1 - Name Search string     -O - Object Name          -R - Rise Time [hhmmss]\n");
Pr(" -e - Epoch Year             -u - U2000 Map #          -T - Transit Time\n");
Pr(" -o - Create .gx file         @ - Command File         -S - Set Time\n");
#ifdef GX_Vel
Pr(" -m - (') of Arc from [r,d]  -z - Velocity [nnnnn]m/s  -V - Version Info\n");
#else
Pr(" -m - (') of Arc from [r,d]                            -V - Version Info\n");
#endif
Pr("\n");
Pr(" -f = Output Format string\n");
Pr("        r|d-RA|Declination        u-U2000 map #      R*Rise Time\n");
Pr("        x|y-Major|Minor Diameter  b-Position Angle   T-Transit Time\n");
Pr("      v|p|a-Vis|Photo|Abs Mag     c=Constellation    S*Set Time\n");
Pr("          s-Surface Brightness  1-5-Nth Object Name  e*Elevation\n");
Pr("          .-space                 C=Catalog Name     m-(') of Arc\n");
#ifdef GX_Vel
Pr("          z-Velocity\n");
#endif
Pr("\n");
#undef	Pr
} else {
	switch (*p) {
	  case 'c':
		printf ("  Constellation Mnemonics\n");
		printf ("  -----------------------\n");
		for (i = 1; i <= CON_NAM_N; i+=11) {
			for (j = 0; j < 11; j++)
				printf ("  %s", con_i2a_nam (i+j));
			printf ("\n");
		}
		break;
	  case 'f':
		printf ("  Additional Output Format Descriptors\n");
		printf ("\n");
	  case '1':
	  case 'C':
		printf ("  C  Catalog  FORMAT\n");
		printf ("  -  -------  -----------\n");
#ifdef GX_M
		printf ("  M  Messier  Mnnn\n");
#endif
#ifdef GX_PGC
		printf ("  P  PGC      Pnnnnn\n");
#endif
#ifdef GX_NGC
		printf ("  N  NGC      Nnnnna\n");
#endif
#ifdef GX_IC
		printf ("  I  IC       Innnna\n");
#endif
#ifdef GX_UGC
		printf ("  U  UGC      Unnnnna\n");
#endif
#ifdef GX_UGC
		printf ("  U  UGCA     UAnnnna\n");
#endif
#ifdef GX_MCG
		printf ("  G  MCG      G+nn-nn-nnna\n");
#endif
#ifdef GX_ESO
		printf ("  E  ESO      Ennn-nnna\n");
#endif
#ifdef GX_ARP
		printf ("  A  ARP      Annnna\n");
#endif
#ifdef GX_MK
		printf ("  K  MK       Knnnna\n");
#endif
#ifdef GX_VV
		printf ("  V  VV       Vnnnna\n");
#endif
		break;
	  default:
		printf ("no help available\n");
		break;
	}
}

exit (0);
}

