/*
 *            Gax - Galaxy, Amateur Astronomical Database
 *       Copyright (C) 1998 - manders1@csc.com (Mark Anderson)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details in file GNU-GPL.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gax_cat.h>

ubyte_t	 a [16];

UB *blk (n)
long_t	 n;
{
	ubyte_t	*p = a;

	while (n--) *p++ = ' ';
	*p++ = 0;

	return (a);
}
UB *dsh (n)
long_t	 n;
{
	ubyte_t	*p = a;

	while (n--) *p++ = '-';
	*p++ = 0;

	return (a);
}
UB *hdr (s, n)
ubyte_t	*s;
 long_t	 n;
{
	ubyte_t	*p = a;
	 long_t	 i, j;

	i = strlen (s);
	j = (n - i) / 2;
	i =  n - i - j;
/*	printf ("\nn=%d   s=%d   i=%d   j=%d", n, strlen (s), i, j); */
	while (i--) *p++ = ' ';
/*	while (*p++ = *s++) ;    COMPILER BUG ??? */
	while (*s ) *p++ = *s++;
	while (j--) *p++ = ' ';
	            *p++ = 0;
/*	printf ("   s='%s'\n", a); */
	return (a);
}

UB *i2a_iii (UB b)
{
	a [3] =  0;
	a [2] =  b     % 10 + '0';
	a [1] = (b/10) % 10 + '0';
	a [0] =  b/100      + '0';

	if (a [0] == '0') {
		a [0] =  ' ';
		if (a [1] == '0')
			a [1] =  ' ';
	}

	return (a);
}

UB *i2a_iiiii (UW b)
{
	a [5] =  0;
	a [4] =  b       % 10 + '0';
	a [3] = (b/10)   % 10 + '0';
	a [2] = (b/100)  % 10 + '0';
	a [1] = (b/1000) % 10 + '0';
	a [0] =  b/10000      + '0';

	if (a [0] == '0') {
		a [0] =  ' ';
		if (a [1] == '0') {
			a [1] =  ' ';
			if (a [2] == '0') {
				a [2] =  ' ';
				if (a [3] == '0')
					a [3] =  ' ';
			}
		}
	}

	return (a);
}

UB *i2a_ii_i (UB b)
{
	if (!b) { strcpy (a, "    "); return (a); }

	a [4] =  0;
	a [3] =  b     % 10 + '0';
	a [2] = '.';
	a [1] = (b/10) % 10 + '0';
	a [0] =  b/100      + '0';

	if (a [0] == '0') {
		a [0] =  ' ';
		if (a [1] == '0')
			a [1] =  ' ';
	}

	return (a);
}

UB *i2a_iii_i (UW b)
{
	if (!b) { strcpy (a, "     "); return (a); }

	a [5] =  0;
	a [4] =  b      % 10 + '0';
	a [3] = '.';
	a [2] = (b/10)  % 10 + '0';
	a [1] = (b/100) % 10 + '0';
	a [0] =  b/1000      + '0';

	if (a [0] == '0') {
		a [0] =  ' ';
		if (a [1] == '0') {
			a [1] =  ' ';
			if (a [2] == '0')
				a [2] =  ' ';
		}
	}

	return (a);
}

/*
UB *i2a_ii (UB *bp)
{
	UB *p = a, c;
	SB	s;

	s = abs (*((SB *) bp));
	
	*p++ = (s / 10) + '0';
	*p++ = (s % 10) + '0';
	*p++ =  0;
}
*/

UB *dsh_ra  () { return (dsh (6)); }
UB *dsh_dec () { return (dsh (7)); }
UB *dsh_con () { return (dsh (3)); }
UB *dsh_maj () { return (dsh (5)); }
UB *dsh_min () { return (dsh (5)); }
UB *dsh_mv  () { return (dsh (4)); }
UB *dsh_mp  () { return (dsh (4)); }
UB *dsh_ma  () { return (dsh (4)); }
UB *dsh_sb  () { return (dsh (4)); }
UB *dsh_vel () { return (dsh (5)); }
UB *dsh_pa  () { return (dsh (3)); }
UB *dsh_u2k () { return (dsh (3)); }
UB *dsh_ris () { return (dsh (4)); }
UB *dsh_set () { return (dsh (4)); }
UB *dsh_tra () { return (dsh (4)); }
UB *dsh_el  () { return (dsh (2)); }

UB *hdr_ra  () { return (hdr ("RA"  ,6)); }
UB *hdr_dec () { return (hdr ("DEC" ,7)); }
UB *hdr_con () { return (hdr ("CON" ,3)); }
UB *hdr_maj () { return (hdr ("MAJ" ,5)); }
UB *hdr_min () { return (hdr ("MIN" ,5)); }
UB *hdr_mv  () { return (hdr ("Mv"  ,4)); }
UB *hdr_mp  () { return (hdr ("Mp"  ,4)); }
UB *hdr_ma  () { return (hdr ("Ma"  ,4)); }
UB *hdr_sb  () { return (hdr ("SB"  ,4)); }
UB *hdr_vel () { return (hdr ("Vel" ,5)); }
UB *hdr_pa  () { return (hdr ("PA"  ,3)); }
UB *hdr_u2k () { return (hdr ("U2K" ,3)); }
UB *hdr_ris () { return (hdr ("RTim",4)); }
UB *hdr_set () { return (hdr ("STim",4)); }
UB *hdr_tra () { return (hdr ("TTim",4)); }
UB *hdr_el  () { return (hdr ("EL"  ,2)); }

UB *i2a_maj (UW b) { return (i2a_iii_i (b)); }
UB *i2a_min (UW b) { return (i2a_iii_i (b)); }
UB *i2a_mv  (UB b) { return (i2a_ii_i  (b)); }
UB *i2a_mp  (UB b) { return (i2a_ii_i  (b)); }
UB *i2a_ma  (UB b) { return (i2a_ii_i  (b)); }
UB *i2a_sb  (UB b) { return (i2a_ii_i  (b)); }
UB *i2a_vel (UW b) { return (i2a_iiiii (b)); }

UB *i2a_pa  (UB b)
{
	if (b == (UB) ~0)
		 strcpy (a, "   ");
	else
		 i2a_iii (b);

	return (a);
}

UB *i2a_ra (SL R)
{
	UB	h, m, s;

	s =  R % 60;
	m = (R / 60) % 60;
	h =  R / 3600;

	a [6] = 0;
	a [5] = s % 10 + '0';
	a [4] = s / 10 + '0';
	a [3] = m % 10 + '0';
	a [2] = m / 10 + '0';
	a [1] = h % 10 + '0';
	a [0] = h / 10 + '0';

	return (a);
}

UB *i2a_dec (SL D)
{
	UB	d, m, s;

	if (D < 0) { a [0] = '-'; D = -D; }
	else         a [0] = '+';


	s =  D % 60;
	m = (D / 60) % 60;
	d =  D / 3600;

	a [7] = 0;
	a [6] = s % 10 + '0';
	a [5] = s / 10 + '0';
	a [4] = m % 10 + '0';
	a [3] = m / 10 + '0';
	a [2] = d % 10 + '0';
	a [1] = d / 10 + '0';

	return (a);
}

UB *i2a_u2k (SL r, SL d)
{
	UL	m = u2k_map (r, d);

	a [3] = 0;
	a [2] =  m % 10 + '0';
	a [1] = (m / 10) % 10 + '0';
	a [0] = (m / 100) + '0';

	if (a [0] == '0') {
		a [0] = ' ';
		if (a [1] == '0')
			a [1] = ' ';
	}

	return (a);
}

/*
 *	i2a_hm - convert seconds to hhmm
 */
UB *i2a_hm (SL S)
{
	UB	h, m;

	m = (S / 60) % 60;
	h =  S / 3600;

	a [4] = 0;
	a [3] = m % 10 + '0';
	a [2] = m / 10 + '0';
	a [1] = h % 10 + '0';
	a [0] = h / 10 + '0';

	return (a);
}

