/*
 *            Gax - Galaxy, Amateur Astronomical Database
 *       Copyright (C) 1998 - manders1@csc.com (Mark Anderson)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details in file GNU-GPL.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	U2K_H
#define	U2K_h

typedef struct u2k_map_s u2k_map_t;
struct u2k_map_s {
	 long_t	 dec_n;		/* lower declination */
	uword_t	 map_n;		/* start map number  */
	ubyte_t	 cnt_n;		/* numbr of maps in band */
};

#define	U2K_MAP_N	18
#define	U2K_MAP_MAX	473

#define	D(d)	d * 3600

u2k_map_t	u2k_map_a [] = {
	D (+90),   0,  0,		/*    */
	D (+84),   1,  2,		/* +8 */
	D (+72),   3, 12,		/* +7 */
	D (+61),  15, 20,		/* +6 */
	D (+50),  35, 24,		/* +5 */
	D (+39),  59, 30,		/* +4 */
	D (+28),  89, 36,		/* +3 */
	D (+17), 125, 45,		/* +2 */
	D (+06), 170, 45,		/* +1 */
	D (-06), 215, 45,		/*  0 */
	D (-17), 260, 45,		/* -1 */
	D (-28), 305, 45,		/* -2 */
	D (-39), 350, 36,		/* -3 */
	D (-50), 386, 30,		/* -4 */
	D (-61), 416, 24,		/* -5 */
	D (-72), 440, 20,		/* -6 */
	D (-84), 460, 12,		/* -7 */
	D (-90), 472,  2		/* -8 */
};

#endif
